## xloadimage 4.1

=== Makefile ===
# Makefile for xloadimage.  this replaces the multiple makefiles used in
# versions prior to xloadimage 2.00.
#
# WARNING: if you use gcc 1.37, there is an optimizer bug which causes GIF
# images to come out black and colormap reduction to fail.  Use gcc-1-37 as
# your make target if you have gcc 1.37.

# Include system configuration parameters
include Make.conf

CFLAGS=$(OPT_FLAGS) $(CC_FLAGS) $(CC_CONFIG_FLAGS) $(X11_INC_DIR) \
  -DSYSPATHFILE=\"$(SYSPATHFILE)\"
LIBS=$(X11_LIB_DIR) $(X11_LIB_NAME) $(SYS_LIBS) -lm

# stuff that should eventually make the configuration file
SYSPATHFILE=/usr/lib/X11/Xloadimage

default: configure$(CONFIG_STYLE)
	$(MAKE) xloadimage
	$(MAKE) uufilter

# this target gets hit automatically on the first run; it sets up
# the Make.conf file and recursively calls make.

autoconfig: autoconfig.c
	$(CC) -g -o autoconfig autoconfig.c

# manual configuration target
configure:: autoconfig
	./autoconfig
	$(MAKE) configure-libraries

# this is the default target for the initial compilation
configure-auto:: autoconfig
	./autoconfig
	$(MAKE) configure-libraries

# target that doesn't do anything	
configure-skip::
	@echo "Already configured, skipping configuration process."

configure-clean:: autoconfig
	./autoconfig -clean
	echo "# this will contain information generated by libconfig" > jpeg.conf
	echo "# this will contain information generated by libconfig" > tiff.conf
	cd jpeg ; make clean
	cd tiff ; make clean

# specific configurations
configure-bsd:: autoconfig
	./autoconfig -bsd
	$(MAKE) configure-libraries

configure-sysv:: autoconfig
	./autoconfig -sysv
	$(MAKE) configure-libraries

# this program configures optional libraries
configure-libraries::
	$(CC) $(CC_FLAGS) -g -o libconfig libconfig.c
	./libconfig "$(CC)" "$(OPT_FLAGS)"

MISC= Imakefile Makefile Makefile.std VMS_BUILD.COM README build-imake \
      build-vms build-info buildshar.c packtar.c xloadimage.man \
      xloadimage.txt autoconfig.c Make.conf libconfig.c \
      makefloppy jpeg.c tiff.c uufilter.man uufilter.txt uufilter.c \
      xloadimagerc

# files for the loader library
LOADER_HDRS= cmuwmraster.h fbm.h gif.h imagetypes.h img.h \
             kljcpyrght.h mac.h mcidas.h mit.cpyrght mrmcpyrght.h \
             niff.h pbm.h pcx.h pds.h rle.h sunraster.h xwd.h tgncpyrght.h 
LOADER_SRCS= cmuwmraster.c faces.c fbm.c gif.c imagetypes.c img.c \
             mac.c mcidas.c mc_tables.c pbm.c pcx.c pdsuncomp.c \
             rle.c rlelib.c sunraster.c vff.c vicar.c xbitmap.c xpixmap.c \
             xwd.c
LOADER_OBJS= ${LOADER_SRCS:.c=.o}

# files for the image library
IMAGE_HDRS= copyright.h image.h
IMAGE_SRCS= new.c niff.c value.c zio.c
IMAGE_OBJS= ${IMAGE_SRCS:.c=.o}

# files for the image processing library
PROCESS_HDRS=
PROCESS_SRCS= bright.c clip.c compress.c dither.c fill.c halftone.c \
              merge.c reduce.c rotate.c smooth.c undither.c zoom.c
PROCESS_OBJS= ${PROCESS_SRCS:.c=.o}

OPTIONAL_OBJS= ${OPTIONAL_SRCS:.c=.o}

# files for xloadimage (X display utility)
X_HDRS= options.h patchlevel xloadimage.h
X_SRCS= config.c misc.c options.c root.c send.c window.c \
        xloadimage.c
X_OBJS= ${X_SRCS:.c=.o}

INCS= $(IMAGE_HDRS) $(LOADER_HDRS) $(PROCESS_HDRS) $(X_HDRS)
SRCS= $(IMAGE_SRCS) $(LOADER_SRCS) $(PROCESS_SRCS) $(X_SRCS) $(OPTIONAL_SRCS)
OBJS= $(IMAGE_OBJS) $(LOADER_OBJS) $(PROCESS_OBJS) $(X_OBJS) $(OPTIONAL_OBJS)

ALL= $(MISC) $(INCS) $(SRCS)

.c.o: Make.conf xloadimage.h image.h $*.c
	$(CC) -c $(CFLAGS) $*.c

jpeg.o: Make.conf image.h
	$(CC) -c $(CFLAGS) -Ijpeg $*.c

uufilter: uufilter.c
	$(CC) -o uufilter $(CFLAGS) uufilter.c

xloadimage: $(OBJS) $(OPTIONAL_LIBS)
	./build-info
	$(CC) -c $(CFLAGS) build.c
	$(CC) -o xloadimage $(CFLAGS) build.o $(OBJS) $(OPTIONAL_LIBS) $(LIBS)

install:: $(SYSPATHFILE) uufilter
	$(RM) $(INSTALLDIR)/xloadimage
	$(RM) $(INSTALLDIR)/xsetbg
	$(RM) $(INSTALLDIR)/xview
	$(RM) $(INSTALLDIR)/uufilter
	$(CP) xloadimage $(INSTALLDIR)/xloadimage
	$(LN) $(INSTALLDIR)/xloadimage $(INSTALLDIR)/xsetbg
	$(LN) $(INSTALLDIR)/xloadimage $(INSTALLDIR)/xview
	$(CP) uufilter $(INSTALLDIR)/uufilter

clean::
	rm -f autoconfig
	make configure-clean
	rm -f *.o *~ xloadimage uufilter autoconfig libconfig packtar \
	  buildshar doshar shar.* *.tar *.tar.Z *.tc

$(SYSPATHFILE):
	@echo "*** Creating default $(SYSPATHFILE) since you"
	@echo "*** don't have one. This file is used to set up default places"
	@echo "*** and names to look for images.  You probably want to edit"
	@echo "*** it for your site.  See the xloadimage manual page for"
	@echo "*** details on the contents of this file."
	cp xloadimagerc $(SYSPATHFILE)

# this is for building Imakefiles and such for distributions

new-auxiliaries:: clean
	rm -f Imakefile Makefile.std VMS_BUILD.COM xloadimage.txt
	cp Makefile Makefile.std # backup in case they want it
	./build-imake "$(SRCS)" "$(OBJS)"
	./build-vms "$(SRCS)" "$(OBJS)"
	./default-info
	nroff -Tcrt -man xloadimage.man > xloadimage.txt
	nroff -Tcrt -man uufilter.man > uufilter.txt

# these targets are for building shar distributions

buildshar: buildshar.o
	$(CC) -o buildshar buildshar.o

shar:: buildshar new-auxiliaries
	rm -f shar.* doshar
	./buildshar $(ALL) > doshar
	sh doshar
	rm -f doshar Makefile.std

# targets for building tar distributions

packtar: packtar.c
	$(CC) -o packtar packtar.c

tar:: new-auxiliaries packtar
	./packtar $(ALL) sample/* jpeg/* tiff/*
	rm -f Imakefile Makefile.std

tar.Z: tar
	compress xloadimage.tar

# create a floppy-disk distribution.

floppy: new-auxiliaries
	./makefloppy $(ALL) sample
	./makefloppy tiff
	./makefloppy jpeg
	rm -f Imakefile Makefile.std

# these targets are for those of us who have CodeCenter/Saber-C

# load all objects in CodeCenter.

cl_obj: $(DEBUG_OBJS)
	#setopt ccargs -g $(CC_FLAGS) $(X11_INC_DIR) -DSYSPATHFILE=\\\"$(SYSPATHFILE)\\\"
	#setopt load_flags $(CC_FLAGS) $(X11_INC_DIR) -DSYSPATHFILE=\\\"$(SYSPATHFILE)\\\"
	#load build.o $(OBJS) $(OPTIONAL_LIBS) $(LIBS)
	#link

# load all sources in CodeCenter.

cl_src:
	#setopt ccargs -g $(CC_FLAGS) $(X11_INC_DIR) -DSYSPATHFILE=\\\"$(SYSPATHFILE)\\\"
	#setopt load_flags $(CC_FLAGS) $(X11_INC_DIR) -DSYSPATHFILE=\\\"$(SYSPATHFILE)\\\"
	#load build.c $(SRCS) $(OPTIONAL_LIBS) $(LIBS)
	#link

# proof xloadimage using TestCenter.

xloadimage.tc:
	proof -errors $(CC) -o xloadimage.tc build.o $(CFLAGS) $(OBJS) $(OPTIONAL_LIBS) $(LIBS)

jpeg/libjpeg.a:
	cd jpeg ; $(MAKE) libjpeg.a

tiff/libtiff.a:
	cd tiff ; $(MAKE) libtiff.a

# a few dependencies
imagetypes.o: imagetypes.h imagetypes.c

=== debian/changelog ===
xloadimage (4.1-27) unstable; urgency=high

  * Update renamed lintian tag names in lintian overrides.
  * Modernise d/rules, bump S-V
  * Tell GCC 15 we’d like to keep pre-C23 (Closes: #1098151)
  * manpage overhaul: merge the fixes from Bjarni Ingi Gislason
    (Closes: #1094315); fold manpage-fix diffs; cease installing
    them as .1x (wtf); drop \(hy used manually for hyphens;
    correctly wrap input lines (begun; this needs mdoc conversion);
    fix .TH dates and some spellings

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 14 Sep 2025 00:30:26 +0000

xloadimage (4.1-26) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Change Format URL to correct one

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Helmut Grohne ]
  * Fix FTCBFS: switch to dh_auto_configure (Closes: #877607)

  [ Christian "naddy" Weisgerber ]
  * Fix LP64 concerns (Closes: #491707)

  [ Thorsten Glaser ]
  * Take over as maintainer to keep this in Debian, but keep
    #919265 open as RFH so others who know more about X11 join
  * Fix memory exhaustion when rotating by 0° (Closes: #971428)
  * Support "-" as argument for stdin (Closes: #420744)
  * Fix building with GCC 14 and gmake 4.3 (Closes: #1075669)
  * A round of lintian, and R³:no
  * Don’t install the upstram changelog’s text in two files
  * Use era-appropriate CFLAGS

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 05 Aug 2024 04:19:19 +0200

xloadimage (4.1-25) unstable; urgency=medium

  * Raise priorities to 2 in mime. (Closes: #752060)
    + Reason was to make it equal to imagemagick and others.
  * Move to Salsa.
  * Update my mail address.
  * Update Standards-Version and dh level.
    + No changes needed.

 -- Dominik George <natureshadow@debian.org>  Mon, 26 Mar 2018 15:58:59 +0200

xloadimage (4.1-24) unstable; urgency=medium

  * Add patch to make build reproducible. (Closes: #831743)
    + Thanks to Chris Lamb!
  * Bump Standards-Version and compat level.
  * Fix watch file.
    + X.org unpublished the R5contrib repo. Using GWDG mirror now.
  * Make package lintian clean.
    + Fix order of copyright file.
    + Fix minor spelling issue with a patch.
    + Use pathfind() from devref 6.4 in maintainer scripts.
  * Rename files in debian/ for consequent naming scheme.
  * Add VCS fields.

 -- Dominik George <nik@naturalnet.de>  Mon, 03 Oct 2016 16:10:21 +0200

xloadimage (4.1-23) unstable; urgency=medium

  * Fix syntax error in mailcap data, thanks to Hilmar Preuße
    and Thorsten Glaser. (Closes: #747322)
  * Add image/pcx mime type, thanks to Kevin Ryde. (Closes: #723725)
  * Comply with standards version 3.9.5.

 -- Dominik George <nik@naturalnet.de>  Wed, 28 May 2014 22:36:43 +0200

xloadimage (4.1-22) unstable; urgency=low

  * Change maintainer to myself. (Closes: #527575)
  * Re-license d/r under GPL-2+ as per the custom license
    given by the original author.
  * Fix build log checks.
    - make build system respect all hardening flags.
    - fix implicit declaration
  * Do not resize images smaller than the screen with -shrink
    (David Frey). (Closes: #381382)
  * Fix -fullscreen behaviour for special gemoetry cases
    (Anton Khirnov). (Closes: #506343)
  * Replace hyphens by correct minus signs for options and others
    in *.man.
  * Builds with both libtiff4-dev and libtiff5-dev.

 -- Dominik George <nik@naturalnet.de>  Wed, 02 Oct 2013 19:37:32 +0200

xloadimage (4.1-21) unstable; urgency=low

  * QA upload.
  * Build-depend on libtiff-dev rather than libtiff4-dev.

 -- Colin Watson <cjwatson@debian.org>  Tue, 04 Sep 2012 10:25:08 +0100

xloadimage (4.1-20) unstable; urgency=low

  * QA upload.
  * Fix jpeg.c build if C_ARITH_CODING_SUPPORTED is
    defined. (Closes: #662619)

 -- Colin Watson <cjwatson@debian.org>  Fri, 10 Aug 2012 14:45:30 +0100

xloadimage (4.1-19) unstable; urgency=low

  * QA upload.
  * Adjust hardening flags to include LDFLAGS for uufilter.
    Thanks to Simon Ruderich <simon@ruderich.org>. (Closes: #670819)

 -- Jari Aalto <jari.aalto@cante.net>  Sun, 29 Apr 2012 18:40:30 +0300

xloadimage (4.1-18) unstable; urgency=low

  * QA upload.
  * Remove deprecated dpatch and upgrade to packaging format
    "3.0 quilt". (Closes: #664370)
  * Update to Standards-Version to 3.9.3, debhelper 9, Copyright Format 1.0.
  * Migrate to dh(1) with new files: debian/{docs,dirs} etc.
  * Enable all hardened build flags.
  * Add watch file and add generate upstream changelog.
  * debian/patches
    - (16, 18): Run "quilt refresh" to make them apply cleanly.
    - (22): New; fix missing header files.
    - (20, 21): Rename to libpng and correct patch Subject text.

 -- Jari Aalto <jari.aalto@cante.net>  Fri, 20 Apr 2012 16:33:51 +0300

xloadimage (4.1-17) unstable; urgency=low

  * QA upload
  * Set maintainer to Debian QA Group
  * Switch to source format 3
  * Add patch by Nobuhiro Iwamatsu to fix compatibility
    with libpng 1.5. (Closes: #635706)
  * Build-depend on libpng-dev. (Closes: #662562)

 -- Moritz Muehlenhoff <jmm@debian.org>  Tue, 13 Mar 2012 23:07:33 +0100

xloadimage (4.1-16.3) unstable; urgency=low

  * Non-maintainer upload.
  * Change Build-Depends from libjpeg62-dev to libjpeg-dev. (Closes: #634647)

 -- gregor herrmann <gregoa@debian.org>  Sun, 06 Nov 2011 17:45:02 +0100

xloadimage (4.1-16.2) unstable; urgency=low

  * Non-maintainer upload.
  * Lower MIME priority for images to 1 (second to lowest), because
    xloadimage can be used to view images, but it's surely not the
    most preferred choice. (Closes: #470663)

 -- martin f. krafft <madduck@debian.org>  Fri, 25 Mar 2011 08:45:49 +0100

xloadimage (4.1-16.1) unstable; urgency=high

  * Non-maintainer upload.
  * 19_fix_root.c_resouce-leak.dpatch:
    Fix leaking xresources when using --onroot. (Closes: #325689)
    Patch by Alex Perry, reformatted by Tim Connors, thanks!


=== debian/control ===
Source: xloadimage
Section: graphics
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 file,
 libjpeg-dev,
 libpng-dev,
 libtiff-dev,
 libx11-dev,
 libxau-dev,
 libxdmcp-dev,
 libxt-dev,
Maintainer: Thorsten Glaser <tg@mirbsd.de>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/xloadimage.git
Vcs-Browser: https://salsa.debian.org/debian/xloadimage

Package: xloadimage
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Graphics file viewer under X11
 Can view png, jpeg, gif, tiff, niff, sunraster, fbm, cmuraster, pbm, faces,
 rle, xwd, vff, mcidas, vicar, pcx, gem, macpaint, xpm and xbm files. Can
 view images, put them on the root window, or dump them. Does a variety of
 processing, including: clipping, dithering, depth reduction, zoom,
 brightening/darkening and merging.
 .
 Includes xsetbg, xview and uufilter.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C
export LC_ALL
TZ:=UTC
export TZ

shellescape='$(subst ','\'',$(1))'
shellexport=$(1)=$(call shellescape,${$(1)})

include /usr/share/dpkg/architecture.mk
DPKG_EXPORT_BUILDTOOLS:=1
include /usr/share/dpkg/buildtools.mk

OUR_CPPFLAGS:=
OUR_CFLAGS:=
OUR_LDFLAGS:=

ifneq (,$(filter debug,${DEB_BUILD_OPTIONS}))
OUR_CFLAGS+=	-Og -g3
endif

OUR_CFLAGS+=	-Wall
OUR_CFLAGS+=	-Wformat
# we are dealing with extremely ancient software here, give it a chance
OUR_CFLAGS+=	-fno-strict-aliasing -fwrapv
# this is mildly prototyped K&R-style code in large parts
OUR_CFLAGS+=	-std=gnu89

dpkgbuildflagsmkescape=$(subst \,\\\,$(1))
export DEB_BUILD_MAINT_OPTIONS:=hardening=+all optimize=-lto
export DEB_CPPFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CPPFLAGS})
export DEB_CFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CFLAGS})
export DEB_LDFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_LDFLAGS})
include /usr/share/dpkg/default.mk

execute_before_dh_auto_clean:
	if grep -Fq 'configure-clean:: autoconfig' Makefile >/dev/null 2>&1; then \
		rm Makefile; \
	fi

execute_before_dh_clean:
	rm -f build *.o xloadimage uufilter build.c config.log config.cache \
	    config.status config.h Makefile jpeg.conf tiff.conf
	rm -rf debian/tmp debian/files* debian/substvars debian/patched
	find . -name \*~ | xargs rm -vf

execute_before_dh_auto_configure:
	chmod 755 build-info configure

override_dh_installchangelogs:
	dh_installchangelogs debian/upstream.changelog

install_dir=install -d -m 755
install_file=install -m 644
install_script=install -m 755
install_binary=install -m 755

override_dh_auto_install:
	$(install_binary) xloadimage debian/xloadimage/usr/bin/
	ln -s xloadimage debian/xloadimage/usr/bin/xsetbg
	ln -s xloadimage debian/xloadimage/usr/bin/xview
	$(install_binary) uufilter debian/xloadimage/usr/bin/

	$(install_file) xloadimagerc debian/xloadimage/etc/X11/Xloadimage

	$(install_file) debian/mime debian/xloadimage/usr/lib/mime/packages/xloadimage

	$(install_dir) debian/xloadimage/usr/share/man/man1/
	$(install_file) xloadimage.man debian/xloadimage/usr/share/man/man1/xloadimage.1
	$(install_file) uufilter.man debian/xloadimage/usr/share/man/man1/uufilter.1
	ln -s xloadimage.1.gz debian/xloadimage/usr/share/man/man1/xsetbg.1.gz
	ln -s xloadimage.1.gz debian/xloadimage/usr/share/man/man1/xview.1.gz

%:
	dh $@

=== debian/watch ===
# X.org unpublished the R5contrib repo. GWDG has a mirror.
version=4
https://ftp.gwdg.de/pub/x11/x.org/R5contrib/xloadimage.([\d.]+).tar.gz
